% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulation_report.R
\name{get_eval_data}
\alias{get_eval_data}
\title{Gets evaluation data from both TMB and DESeqDataSet (dds) objects.}
\usage{
get_eval_data(l_tmb = NULL, dds = NULL, mock_obj, coefficient, alt_hypothesis)
}
\arguments{
\item{l_tmb}{A list of TMB models (default is NULL).}

\item{dds}{A DESeqDataSet object (default is NULL).}

\item{mock_obj}{A mock object containing ground truth information.}

\item{coefficient}{Threshold value for coefficient testing (default is 0). This threshold corresponds to the natural logarithm of the fold change (ln(FC)).}

\item{alt_hypothesis}{The alternative hypothesis for wald test}
}
\value{
A list containing data frames for model parameters and dispersion.
}
\description{
This function retrieves evaluation data from TMB and DESeqDataSet (dds) objects, combining
the results into a list containing data frames for model parameters and dispersion.
}
