% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/evaluation_withmixedeffect.R
\name{inferenceToExpected_withMixedEff}
\alias{inferenceToExpected_withMixedEff}
\title{Compare the mixed-effects inference to expected values.}
\usage{
inferenceToExpected_withMixedEff(tidy_tmb, ground_truth_eff)
}
\arguments{
\item{tidy_tmb}{tidy model results obtained from fitting a mixed-effects model.}

\item{ground_truth_eff}{A data frame containing ground truth effects.}
}
\value{
A data frame with the comparison of estimated mixed effects to expected values.
}
\description{
This function compares the mixed-effects inference obtained from a mixed-effects model to expected values derived from a ground truth dataset.
The function assumes a specific type I mixed-effect structure in the input model.
}
\examples{
\dontrun{
inferenceToExpected_withMixedEff(tidy_tmb(l_tmb), ground_truth_eff)
} 
}
