% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/update_fittedmodel.R
\name{launchUpdate}
\alias{launchUpdate}
\title{Launch the update process for a GLMNB model.}
\usage{
launchUpdate(glmm_obj, formula, ...)
}
\arguments{
\item{glmm_obj}{A glmmTMB object to be updated.}

\item{formula}{Formula for the updated GLMNB model.}

\item{...}{Additional arguments to be passed to the glmmTMB::glmmTMB function.}
}
\value{
An updated GLMNB model or NULL if an error occurs.
}
\description{
This function launches the update process for a GLMNB model, capturing and handling warnings and errors.
}
\examples{
data(iris)
groups <- unique(iris$Species)
group_by <- "Species"
formula <- Sepal.Length ~ Sepal.Width + Petal.Length
fitted_models <- fitModelParallel(formula, iris, group_by, n.cores = 1)
new_formula <- Sepal.Length ~ Sepal.Width 
updated_model <- launchUpdate(fitted_models[[1]], new_formula)
}
