% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepare_data2fit.R
\name{prepareData2fit}
\alias{prepareData2fit}
\title{Prepare data for fitting}
\usage{
prepareData2fit(
  countMatrix,
  metadata,
  normalization = TRUE,
  response_name = "kij",
  groupID = "geneID"
)
}
\arguments{
\item{countMatrix}{Count matrix}

\item{metadata}{Metadata data frame}

\item{normalization}{A boolean value indicating whether to apply median ratio
normalization. If \code{TRUE} (default), the counts matrix will be
normalized using median ratio normalization. If
\code{FALSE}, no normalization will be applied.}

\item{response_name}{String referring to target variable name that is being modeled and predicted (default : "kij")}

\item{groupID}{String referring the group variable name (default : "geneID")}
}
\value{
Data frame for fitting
}
\description{
Prepares the countMatrix and metadata for fitting by converting the countMatrix to a long format and joining with metadata.
}
\examples{
 list_var <- init_variable()
 mock_data <- mock_rnaseq(list_var, n_genes = 3, 2,2)
 data2fit <- prepareData2fit(mock_data$counts, mock_data$metadata)
}
