% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mlmetrics.R
\name{recall}
\alias{recall}
\title{recall}
\usage{
recall(y_true, y_pred, positive = NULL)
}
\arguments{
\item{y_true}{Ground truth (correct) 0-1 labels vector}

\item{y_pred}{Predicted labels vector, as returned by a classifier}

\item{positive}{An optional character string for the factor level that
corresponds to a "positive" result}
}
\value{
recall
}
\description{
Compute the recall score.
}
\examples{
data(cars)
logreg <- glm(formula = vs ~ hp + wt,
              family = binomial(link = "logit"), data = mtcars)
pred <- ifelse(logreg$fitted.values < 0.5, 0, 1)
recall(y_pred = pred, y_true = mtcars$vs, positive = "0")
recall(y_pred = pred, y_true = mtcars$vs, positive = "1")
}
