% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tidy_glmmtmb.R
\name{wrapper_var_cor}
\alias{wrapper_var_cor}
\title{Wrapper for Extracting Variance-Covariance Components}
\usage{
wrapper_var_cor(var_cor, elt)
}
\arguments{
\item{var_cor}{A variance-covariance object from the glmmTMB model.}

\item{elt}{A character indicating the type of effect, either "cond" or "zi".}
}
\value{
A data frame containing the standard deviation and correlation components for the specified grouping factor.
}
\description{
This function extracts variance-covariance components from a glmmTMB model object for a specific grouping factor and returns them as a data frame.
}
\examples{
model <- glmmTMB::glmmTMB(Sepal.Length ~ Sepal.Width + Petal.Length + (1|Species), 
                           data = iris, family = gaussian)
var_cor <- summary(model)$varcor$cond
ran_pars_df <- wrapper_var_cor(var_cor, "Species")
}
