# WARNING - Generated by {fusen} from /dev/flat_full.Rmd: do not edit by hand


test_that("generate_basal_expression returns correct number of genes", {
  be_data <- generate_basal_expression(n_genes = 100, 1)
  expect_equal(nrow(be_data), 100)
})


test_that("generate_basal_expression returns BE values within specified vector", {
  BE_vec <- c(1, 2, 33, 0.4)
  be_data <- generate_basal_expression(n_genes = 100, BE_vec)
  expect_true(all(be_data$basalExpr %in% BE_vec))
})


test_that("Test for addbasalExpre function",{
  
  list_var <- init_variable()
  N_GENES <- 5
  dtf_coef <- getInput2simulation(list_var, N_GENES)
  dtf_coef <- getLog_qij(dtf_coef)

  # Test the function
  dtf_coef_with_BE <- addBasalExpression(dtf_coef, N_GENES, 5)

  # Check if the output is a data frame
  expect_true(is.data.frame(dtf_coef_with_BE))

  # Check if the number of rows is equal to number of row in dtf_coef
  expect_equal(nrow(dtf_coef_with_BE), nrow(dtf_coef))
  
  # Check if the number of rows is equal to number of row in dtf_coef +1
  expect_equal(ncol(dtf_coef_with_BE), ncol(dtf_coef)+1)
  
  # Check if the data frame has a new column "BE"
  expect_true("basalExpr" %in% colnames(dtf_coef_with_BE))
  
  # Check if the values in the "BE" column are numeric
  expect_true(all(is.numeric(dtf_coef_with_BE$basalExpr)))

})


# Test 1: Check if the function returns the correct number of bins
test_that("getBinExpression returns the correct number of bins", {
  dtf <- data.frame(mu_ij = c(10, 20, 30, 15, 25, 35, 40, 5, 12, 22))
  n_bins <- 3
  dtf_with_bins <- getBinExpression(dtf, n_bins)
  expect_equal(nrow(dtf_with_bins), nrow(dtf), label = "Number of rows should remain the same")
  expect_equal(ncol(dtf_with_bins), ncol(dtf) + 1, label = "Number of columns should increase by 1")
})

# Test 2: Check if the function adds the binExpression column correctly
test_that("getBinExpression adds the binExpression column correctly", {
  dtf <- data.frame(mu_ij = c(10, 20, 30, 15, 25, 35, 40, 5, 12, 22))
  n_bins <- 3
  dtf_with_bins <- getBinExpression(dtf, n_bins)
  expected_bins <- c("BinExpression_1", "BinExpression_2", "BinExpression_3", "BinExpression_1", "BinExpression_2",
                     "BinExpression_3", "BinExpression_3", "BinExpression_1", "BinExpression_1", "BinExpression_2")
  expect_equal(dtf_with_bins$binExpression, factor(expected_bins))
})

# Test 3: Check if the function handles negative values correctly
test_that("getBinExpression handles negative values correctly", {
  dtf <- data.frame(mu_ij = c(10, -20, 30, -15, 25, 35, -40, 5, 12, -22))
  n_bins <- 4
  dtf_with_bins <- getBinExpression(dtf, n_bins)
  expected_bins <- c("BinExpression_3", "BinExpression_2", "BinExpression_4", "BinExpression_2", "BinExpression_4",
                     "BinExpression_4", "BinExpression_1", "BinExpression_3", "BinExpression_3", "BinExpression_1")
  expect_equal(dtf_with_bins$binExpression, factor(expected_bins))
})



