# WARNING - Generated by {fusen} from /dev/flat_full.Rmd: do not edit by hand


test_that("endsWithDigit returns the correct result", {
  expect_true(endsWithDigit("abc123"))
  expect_false(endsWithDigit("xyz"))
})

test_that("removeDigitsAtEnd removes digits at the end of a string", {
  expect_equal(removeDigitsAtEnd("abc123"), "abc")
  expect_equal(removeDigitsAtEnd("xyz"), "xyz")
})


test_that("init_variable initializes a variable correctly", {
  # Test case 1: Initialize a variable with default parameters
  list_var <- init_variable()
  expect_true("myVariable" %in% names(list_var))
  expect_equal(nrow(list_var$myVariable$data), 2)
  
  # Test case 2: Initialize a variable with custom parameters
  list_var <- init_variable(name = "custom_variable", mu = c(1, 2, 3), sd = 0.5, level = 3)
  expect_true("customvariable" %in% names(list_var))
  expect_equal(nrow(list_var$customvariable$data), 3)
})

test_that("inputs_checking performs input validation", {
  
  # Test case 1: Invalid inputs - sd is NA but mu has unique values
  expect_error(inputs_checking(list_var = c(), name = "myVariable", mu = 2, sd = NA, level = 2))
  
  # Test case 2: Invalid inputs - empty name
  expect_error(inputs_checking(list_var = c(), name = "", mu = 2, sd = NA, level = 2))
  
  # Test case 3: Invalid inputs - non-numeric mu
  expect_error(inputs_checking(list_var = c(), name = "myVariable", mu = "invalid", sd = NA, level = 2))
  
  # Test case 4: Invalid inputs - non-numeric sd
  expect_error(inputs_checking(list_var = c(), name = "myVariable", mu = 2, sd = "invalid", level = 2))
  
  # Test case 5: Invalid inputs - level less than 2
  expect_error(inputs_checking(list_var = c(), name = "myVariable", mu = 2, sd = NA, level = 1))
  
  # Test case 6: Invalid inputs - mu and level have different lengths
  expect_error(inputs_checking(list_var = c(), name = "myVariable", mu = c(1, 2, 3), sd = NA, level = 2))
  
  # Test case 7: Valid inputs
  expect_silent(inputs_checking(list_var = c(), name = "myVariable", mu = c(1, 2, 3), sd = NA, level = 3))
})



test_that("already_init_variable checks if a variable is already initialized", {
  list_var <- init_variable()
  
  # Test case 1: Variable not initialized
  list_var <- init_variable(name = "custom_variable", mu = c(2, 3), sd = NA, level = 2)
  expect_true(already_init_variable(list_var, "customvariable"))
  
  # Test case 2: Variable already initialized 
  expect_false(already_init_variable(list_var, "myVariable"))
  
})

test_that("fillInVariable fills in variable correctly", {
  # Test case 1: Effects given by user
  sub_obj <- fillInVariable("myVariable", c(1, 2, 3), NA, NA)
  expect_equal(sub_obj$level, 3)
  expect_equal(ncol(sub_obj$data), 2)
  
  # Test case 2: Effects simulated using mvrnorm
  sub_obj <- fillInVariable("myVariable", 2, 0.5, 3)
  expect_equal(sub_obj$level, 3)
  expect_equal(sub_obj$sd, 0.5)
  expect_equal(sub_obj$mu, 2)
})

test_that("build_sub_obj_return_to_user returns the expected output", {
  level <- 3
  metaData <- paste("label", 1:level, sep = "_")
  effectsGivenByUser <- c(2, 3, 4)
  col_names <- c("metadata", "effects")
  
  result <- build_sub_obj_return_to_user(level, metaData, effectsGivenByUser, col_names)
  
  expect_equal(result$level, level)
  expect_identical(result$data$metadata, metaData)
  expect_identical(result$data$effects, effectsGivenByUser)
  
  
})

test_that("add_interaction adds an interaction between variables", {
  list_var <- init_variable(name = "varA", mu = 1, sd = 1, level = 2)
  list_var <- init_variable(list_var, name = "varB", mu = 2, sd = 1, level = 3)
  list_var <- add_interaction(list_var, between_var = c("varA", "varB"), mu = 0.5, sd = 3)
  expect_true("varA:varB" %in% names(list_var$interactions))
})

test_that("add_interaction throws an error for invalid variables", {
  list_var <- init_variable(name = "varA", mu = 1, sd = 1, level = 2)
  expect_error(add_interaction(list_var, between_var = c("varA", "varB"), mu = 0.5, sd = NA))
})


test_that("getNumberOfCombinationsInInteraction calculates the number of combinations", {
  list_var <- init_variable(name = "varA", mu = 1, sd = 1, level = 2)
  list_var <- init_variable(list_var, name = "varB", mu = 2, sd = 1, level = 3)
  expect_equal(getNumberOfCombinationsInInteraction(list_var, c("varA", "varB")), 6)
})
