# WARNING - Generated by {fusen} from /dev/flat_full.Rmd: do not edit by hand

# Test updateParallel function
test_that("updateParallel function returns correct results", {
  # Load the required data
  data(iris)
  groups <- unique(iris$Species)
  group_by <- "Species"
  formula <- Sepal.Length ~ Sepal.Width + Petal.Length
  fitted_models <- fitModelParallel(formula, iris, group_by, n.cores = 1)
  new_formula <- Sepal.Length ~ Sepal.Width 
  results <- updateParallel(new_formula, fitted_models, n.cores = 1)
  expect_is(results, "list")
  expect_equal(length(results), length(fitted_models))
  expect_is(results$setosa, "glmmTMB")

  #uncorrect formula 
  new_formula <- Sepal.Length ~ blabla
  expect_error(updateParallel(new_formula, fitted_models, n.cores = 1))
  
  # Additional parameters: 
   #change family + formula
  new_formula <- Sepal.Length ~ Sepal.Width 
  updated_model <- suppressWarnings(updateParallel(fitted_models, 
                                                    formula = new_formula,
                                                    n.cores = 1,
                                                    family = glmmTMB::nbinom1(link = "log") ))
  expect_s3_class(updated_model$setosa$call$family, "family")
  expect_equal(updated_model$setosa$call$formula, new_formula)
  #change control settings
  updated_model <- suppressWarnings(updateParallel(fitted_models, 
                                                 formula = new_formula, 
                                                 family = glmmTMB::nbinom1(link = "log"), 
                                                  n.cores = 1,
                                                control = glmmTMB::glmmTMBControl(optCtrl=list(iter.max=1e3,
                                                                                               eval.max=1e3))))
  expect_equal(updated_model$setosa$call$control,  glmmTMB::glmmTMBControl(optCtrl=list(iter.max=1e3,eval.max=1e3)))
  
  # Update an updated model
  updated_updated_model <- suppressWarnings(updateParallel(updated_model, 
                                                 formula = new_formula, 
                                                  n.cores = 1,
                                                 family = glmmTMB::ziGamma(link = "inverse")))
  expect_s3_class(updated_updated_model$setosa$call$family,  "family")
})

# Test parallel_update function
test_that("parallel_update function returns correct results", {
# Load the required data
  data(iris)
  groups <- unique(iris$Species)
  group_by <- "Species"
  formula <- Sepal.Length ~ Sepal.Width + Petal.Length
  fitted_models <- fitModelParallel(formula, iris, group_by, n.cores = 1)
  new_formula <- Sepal.Length ~ Sepal.Width 
  results <- parallel_update(new_formula, fitted_models, n.cores = 1)
  expect_is(results, "list")
  expect_equal(length(results), length(fitted_models))
  expect_is(results$setosa, "glmmTMB")

  #uncorrect formula 
  new_formula <- Sepal.Length ~ blabla
  results <- parallel_update(new_formula, fitted_models, n.cores = 1)
  expect_is(results, "list")
  expect_equal(length(results), length(fitted_models))
  expect_equal(results$setosa, NULL)
  
  # Additional parameters: 
   #change family + formula
  new_formula <- Sepal.Length ~ Sepal.Width 
  updated_model <- suppressWarnings(parallel_update(fitted_models, 
                                                     formula = new_formula,
                                                      n.cores = 1,
                                                      family = glmmTMB::nbinom1(link = "log") ))
  expect_s3_class(updated_model$setosa$call$family, "family")
  expect_equal(updated_model$setosa$call$formula, new_formula)
  #change control
  updated_model <- suppressWarnings(parallel_update(fitted_models, 
                                                 formula = new_formula, 
                                                  n.cores = 1,
                                                 family = glmmTMB::nbinom1(link = "log"), 
                                                control = glmmTMB::glmmTMBControl(optCtrl=list(iter.max=1e3,
                                                                                               eval.max=1e3))))
  expect_equal(updated_model$setosa$call$control,  glmmTMB::glmmTMBControl(optCtrl=list(iter.max=1e3,eval.max=1e3)))
})

# Test fitUpdate function
test_that("fitUpdate function returns correct results", {
  #Load the required data
  data(iris)
  groups <- unique(iris$Species)
  group_by <- "Species"
  formula <- Sepal.Length ~ Sepal.Width + Petal.Length
  fitted_models <- fitModelParallel(formula, iris, group_by, n.cores = 1)
  new_formula <- Sepal.Length ~ Sepal.Width 

  updated_model <- fitUpdate("setosa",fitted_models[[1]], new_formula)
  expect_is(updated_model, "glmmTMB")
  
  ## -- check groupId presence
  expect_equal(updated_model$groupId, "setosa")
  
  # Additional parameters: 
   #change family + formula
  updated_model <- suppressWarnings(fitUpdate("setosa", fitted_models[[1]], new_formula, 
                                              family = glmmTMB::nbinom1(link = "log") ))
  expect_s3_class(updated_model$call$family, "family")
  expect_equal(updated_model$call$formula, new_formula)
  #change control
  updated_model <- suppressWarnings(fitUpdate("setosa", fitted_models[[1]], 
                                              new_formula, 
                                              family = glmmTMB::nbinom1(link = "log"), 
                                              control = glmmTMB::glmmTMBControl(optCtrl=list(iter.max=1e3,
                                                                                               eval.max=1e3))))
  expect_equal(updated_model$call$control,  glmmTMB::glmmTMBControl(optCtrl=list(iter.max=1e3,eval.max=1e3)))
  
})


# Test launchUpdate function
test_that("launchUpdate function returns correct results", {
  data(iris)
  groups <- unique(iris$Species)
  group_by <- "Species"
  formula <- Sepal.Length ~ Sepal.Width + Petal.Length
  fitted_models <- fitModelParallel(formula, iris, group_by, n.cores = 1)
  new_formula <- Sepal.Length ~ Sepal.Width 
  updated_model <- launchUpdate(fitted_models[[1]], new_formula)
  expect_is(updated_model, "glmmTMB")
  # Additional parameters: 
   #change family + formula
  updated_model <- launchUpdate(fitted_models[[1]], new_formula, family = glmmTMB::nbinom1(link = "log") )
  expect_s3_class(updated_model$call$family, "family")
  expect_equal(updated_model$call$formula, new_formula)
  #change control
  updated_model <- launchUpdate(fitted_models[[1]], new_formula, family = glmmTMB::nbinom1(link = "log"), 
                                control = glmmTMB::glmmTMBControl(optimizer=optim, optArgs=list(method="BFGS")))
  expect_equal(updated_model$call$control,  glmmTMB::glmmTMBControl(optimizer=optim, optArgs=list(method="BFGS")))
  
})

