% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mock_rnaseq.R
\name{mock_rnaseq}
\alias{mock_rnaseq}
\title{Perform RNA-seq simulation}
\usage{
mock_rnaseq(
  list_var,
  n_genes,
  min_replicates,
  max_replicates,
  sequencing_depth = NULL,
  basal_expression = 0,
  dispersion = stats::runif(n_genes, min = 0, max = 1000)
)
}
\arguments{
\item{list_var}{List of input variables}

\item{n_genes}{Number of genes}

\item{min_replicates}{Minimum replication count}

\item{max_replicates}{Maximum replication count}

\item{sequencing_depth}{Sequencing depth}

\item{basal_expression}{base expression gene}

\item{dispersion}{User-provided dispersion vector (optional)}
}
\value{
List containing the ground truth, counts, and metadata
}
\description{
Simulates RNA-seq data based on the input variables.
}
\examples{
mock_rnaseq(list_var = init_variable(), 
             n_genes = 1000, min_replicates = 2,   
              max_replicates = 4)
}
